;////////////////////////////////////////////////////////////////////////////;
;/ asm.s                                                                    /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ includes                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
	.include "\dev\gb\lib\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ interrupts                                                               /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_HEADER (ABS)
	.org	0x40
	jp	.vbl_irq
	.org	0x48
	jp	.lcd_irq

;////////////////////////////////////////////////////////////////////////////;
;/ variables                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_BSS

.r1:		.ds 1
.g1:		.ds 1
.b1:		.ds 1

_ib1::		.ds 1
_ir1::		.ds 1
_ig1::		.ds 1

.globl	_scroller_startpal
.globl	_scroller_pal
.globl	_scroller_pals

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ .vbl_irq                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
.vbl_irq:
	push af

	call 0xFF80			;update sprites

	xor	a, a
	ldh	(.LYC), a
	ldh	(.SCX), a

	ld	a, (_scroller_startpal+0)
	ld	(_scroller_pal+0), a
	ld	a, (_scroller_startpal+1)
	ld	(_scroller_pal+1), a

	pop	af
	reti

;////////////////////////////////////////////////////////////////////////////;
;/ .lcd_irq                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
.lcd_irq:
	push af
	push bc
	push hl


	;.globl _stab
	;ld	hl, #_stab
	;add	
;0
;0
;1
;0
;-1
;0
;0


	ld	a, #1
	ldh	(.SCY), a




	ldh	a, (.LY)
	cp	a, #126
	jp	c, .end
	cp	a, #136
	jp	nc, .end


	;and	a, #1
	;jr	nz, .second


	;do sprites
	ld	hl, #0xFE00+4*30+1

1$:
	ldh	a, (.STAT)
	and	a, #0x02
	jr	nz, 1$

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l


	;do palette
	ld	a, (_scroller_pal+0)
	ld	l, a
	ld	a, (_scroller_pal+1)
	ld	h, a

;1$:
	;ldh	a, (.STAT)
	;and	a, #0x02
	;jr	nz, 1$

	ld	a, #2*3 + 128
	ldh	(.OCPS), a
	ld	a, (hl+)
	ldh	(.OCPD), a
	ld	a, (hl+)
	ldh	(.OCPD), a

	ld	a, l
	ld	(_scroller_pal+0), a
	ld	a, h
	ld	(_scroller_pal+1), a

;	jr	.end
	

;.second:
	
	ld	hl, #0xFE00+4*35+1

2$:
	ldh	a, (.STAT)
	and	a, #0x02
	jr	nz, 2$

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l

	ld	a, (hl)
	dec	a
	ld	(hl+), a
	inc	l
	inc	l
	inc	l


.end:
	ldh	a, (.LY)
	add	a, #1
	ldh	(.LYC), a
	
	pop	hl
	pop	bc
	pop	af
	reti
