;////////////////////////////////////////////////////////////////////////////;
;/ compress.s                                                               /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ _Decompress                                                              /;
;////////////////////////////////////////////////////////////////////////////;
_Decompress::
	push bc

	lda	hl, 4(sp)
	ld	a, (hl+)
	ld	e, a
	ld	a, (hl+)
	ld	d, a
	ld	a, (hl+)
	ld	h, (hl)
	ld	l, a


.NextCommand:
	ld a, (hl+)
	or a, a
	jr z, .END

	bit	7,a
	jr	nz, .STR_func	;1xxxxxxx

    bit	6,a
    jr	nz, .RLE_word	;01xxxxxx


.RLE_byte:				;00xxxxxx
	and	a, #63
	inc a
	ld	c, a
	ld	a, (hl+)
1$:
	ld	(de), a
	inc	de
	dec	c
	jr	nz, 1$

	jr	.NextCommand


.RLE_word:				;01xxxxxx
	and	a, #63
	inc	a
	ld	c, a
	
	;load word into bl
	ld	b, (hl)
	inc	hl
	ld	a, (hl+)
	push hl
	ld	l, a
	
1$:
	ld	a, b
	ld	(de), a
	inc	de
	ld	a, l
	ld	(de), a
	inc	de

	dec	c
	jr	nz, 1$

	pop hl
	jr .NextCommand


.STR_func:				;1xxxxxxx
	bit	6, a
	jr	nz, .STR_copy	;11xxxxxx


.STR_repeat:			;10xxxxxx
	and	a, #63
	inc	a

	ld	c, (hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	push hl

	ld	h, d
	ld	l, e
	add	hl, bc
	ld	b, a

1$:
	ld	a, (hl+)
	ld	(de), a
	inc	de
	dec	b
	jr	nz, 1$

	pop	hl
	jr	.NextCommand


.STR_copy:				;11xxxxxx
	and	a, #63
	inc	a
	ld	b, a

1$:
	ld	a, (hl+)
	ld	(de), a
	inc	de
	dec	b
	jr	nz, 1$
	
	jr	.NextCommand


.END:
	pop	bc
	ret
