//////////////////////////////////////////////////////////////////////////////
// data.c                                                                   //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "data.h"
#include "sprtiles.h"

//////////////////////////////////////////////////////////////////////////////
// defines                                                                  //
//////////////////////////////////////////////////////////////////////////////
// GBC palette definitions
#define CGBPAL(id,pal) id##CGBPal##pal##c0,id##CGBPal##pal##c1,id##CGBPal##pal##c2,id##CGBPal##pal##c3
#define CGBPALS(id) {CGBPAL(id,0),CGBPAL(id,1),CGBPAL(id,2),CGBPAL(id,3),CGBPAL(id,4),CGBPAL(id,5),CGBPAL(id,6),CGBPAL(id,7)}

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
UWORD spritepals[] = //CGBPALS();
{
	RGB(0,0,0), RGB(10,10,10), RGB(15,15,15), RGB(31,31,31),
	RGB(0,0,0), RGB( 4, 2, 2), RGB( 6, 3, 3), RGB(10, 8, 8),
	RGB(0,0,0), RGB( 5, 2, 2), RGB( 9, 4, 4), RGB(14,12,12),
	RGB(0,0,0), RGB( 6, 3, 3), RGB(11, 5, 5), RGB(17,15,15),
	RGB(0,0,0), RGB( 7, 3, 3), RGB(14, 7, 7), RGB(21,18,18),
	RGB(0,0,0), RGB( 8, 4, 4), RGB(16, 9, 9), RGB(24,20,20),
	RGB(0,0,0), RGB( 9, 4, 4), RGB(19,11,11), RGB(28,24,24),
	RGB(0,0,0), RGB(10, 5, 5), RGB(21,14,14), RGB(31,28,28),
};

//////////////////////////////////////////////////////////////////////////////
// LoadTiles                                                                //
//////////////////////////////////////////////////////////////////////////////
void LoadTiles()
{
	set_bkg_palette(0,8, palettes);
	VBK_REG=1;
	set_bkg_data(0,104, tiles1);
	//Decompress(0x8800, tiles1);
	set_bkg_tiles(0,0,20,18, attrmap);
	VBK_REG=0;
	set_bkg_data(0,256, tiles0);
	//Decompress(0x8800, tiles0);
	set_bkg_tiles(0,0,20,18, tilemap);
	
	//LCDC_REG |= 0x10;
}

//////////////////////////////////////////////////////////////////////////////
// LoadSprites                                                              //
//////////////////////////////////////////////////////////////////////////////
void LoadSprites()
{
	Decompress(0x8000, sprtiles);
	//set_sprite_data(0,52*2, sprites);
	set_sprite_palette(0,8, spritepals);
	SPRITES_8x16;
}

//////////////////////////////////////////////////////////////////////////////
// InitSprites                                                              //
//////////////////////////////////////////////////////////////////////////////
void InitSprites()
{
	unsigned int s;
	for (s=0; s<40; s++)
	{
		move_sprite(s, 0,0);
		set_sprite_tile(s, 0);
	}
	SHOW_SPRITES;
}

//////////////////////////////////////////////////////////////////////////////
// HideSprites                                                              //
//////////////////////////////////////////////////////////////////////////////
void HideSprites()
{
	HIDE_SPRITES;
}
