;////////////////////////////////////////////////////////////////////////////;
;/ math.s                                                                   /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ includes                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
	.include "\dev\gb\lib\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ variables                                                                /;
;	.area	_BSS
;////////////////////////////////////////////////////////////////////////////;

	.area	_HRAM (ABS)
	.org	0xFFA0

;input vector
_x1::	.ds 1
_y1::	.ds 1
_z1::	.ds 1

;output vector
_x2::	.ds 1
_y2::	.ds 1
_z2::	.ds 1

;rotation 'matrix'
_xx::	.ds 1
_yx::	.ds 1
_zx::	.ds 1
_xy::	.ds 1
_yy::	.ds 1
_zy::	.ds 1
_xz::	.ds 1
_yz::	.ds 1
_zz::	.ds 1

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ .log_mul - a=a*b/128                                                     /;
;////////////////////////////////////////////////////////////////////////////;
.log_mul:
;	ld	d, #0x7E		;0x7F00/0x7F00

	ld	l, a
	xor	a, b
	and	a, #0x80
	ld	a, (hl)
	ld	l, b
	ld	b, (hl)
	jr	z, .log_pos

.log_neg:
	inc	h
	add	a, b
	ld	l, a
	ld	a, (hl)
	dec	h

	cpl
	inc	a
	ret

.log_pos:
	inc	h
	add	a, b
	ld	l, a
	ld	a, (hl)
	dec	h
	ret

;////////////////////////////////////////////////////////////////////////////;
;/ _Mul                                                                     /;
;////////////////////////////////////////////////////////////////////////////;
_Mul::
	push bc
	lda	hl, 4(sp)
	ld	a, (hl+)
	ld	b, (hl)
	ld	h, #0x7E		;0x7F00/0x7F00
	call .log_mul
	ld	e, a
	pop	bc
	ret

;////////////////////////////////////////////////////////////////////////////;
;/ _RotateVertex                                                            /;
;////////////////////////////////////////////////////////////////////////////;
_RotateVertex::
	push bc

	ld	h, #0x7E		;0x7F00/0x7F00


;	x2 = Mul(x1,xx) + Mul(y1,yx) + Mul(z1,zx);

	ld	a, (_x1)
	ld	b, a
	ld	a, (_XX)
	call .log_mul
	push af
	ld	a, (_y1)
	ld	b, a
	ld	a, (_YX)
	call .log_mul
	push af
	ld	a, (_z1)
	ld	b, a
	ld	a, (_ZX)
	call .log_mul
	pop	bc
	add	a, b
	pop	bc
	add	a, b
	ld	(_x2), a

;	y2 = Mul(x1,xy) + Mul(y1,yy) + Mul(z1,zy);

	ld	a, (_x1)
	ld	b, a
	ld	a, (_XY)
	call .log_mul
	push af
	ld	a, (_y1)
	ld	b, a
	ld	a, (_YY)
	call .log_mul
	push af
	ld	a, (_z1)
	ld	b, a
	ld	a, (_ZY)
	call .log_mul
	pop	bc
	add	a, b
	pop	bc
	add	a, b
	ld	(_y2), a

;	z2 = Mul(x1,xz) + Mul(y1,yz) + Mul(z1,zz);

	ld	a, (_x1)
	ld	b, a
	ld	a, (_XZ)
	call .log_mul
	push af
	ld	a, (_y1)
	ld	b, a
	ld	a, (_YZ)
	call .log_mul
	push af
	ld	a, (_z1)
	ld	b, a
	ld	a, (_ZZ)
	call .log_mul
	pop	bc
	add	a, b
	pop	bc
	add	a, b
	ld	(_z2), a


	pop	bc
	ret
