;////////////////////////////////////////////////////////////////////////////;
;/ music.s                                                                  /;
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ includes                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
	.include "\dev\gb\lib\global.s"

;////////////////////////////////////////////////////////////////////////////;
;/ interrupts                                                               /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_HEADER (ABS)
	.org	0x50
	jp	.tim_irq

;////////////////////////////////////////////////////////////////////////////;
;/ variables                                                                /;
;////////////////////////////////////////////////////////////////////////////;
	.area	_BSS

_playtick::	.ds 1
_playpos::	.ds 2
_playloop::	.ds 2
_timctr::	.ds 2
_timmod::	.ds 2

;////////////////////////////////////////////////////////////////////////////;
	.area	_CODE
;////////////////////////////////////////////////////////////////////////////;

.end:
	ld	a, l
	ld	(_playpos+0), a
	ld	a, h
	ld	(_playpos+1), a

	pop	bc
.end2:
	pop	hl
	pop	af
	reti

;////////////////////////////////////////////////////////////////////////////;
;/ .tim_irq                                                                 /;
;////////////////////////////////////////////////////////////////////////////;
.tim_irq:
	push af
	push hl

	
	ld	a, (_timctr+0)
	dec	a
	ld	(_timctr+0), a
	cp	a, #0xFF
	jr	nz, .end2
	ld	a, (_timctr+1)
	dec	a
	ld	(_timctr+1), a
	cp	a, #0xFF
	jr	nz, .end2




	ld	a, (_timmod+0)
	ld	(_timctr+0), a
	ld	a, (_timmod+1)
	ld	(_timctr+1), a

	push bc

	ld	a, (_playpos+0)
	ld	l, a
	ld	a, (_playpos+1)
	ld	h, a

	ld	a, (_playtick)
	cpl
	ld	(_playtick), a
	ld	b, a

.type:
	ld	a, b
	xor	a, (hl)
	bit	7, a
	jr	nz, .end
	
	ld	a, (hl+)
	bit	0, a
	jr	nz, .Sound1
	bit	1, a
	jr	nz, .Sound2
	bit	2, a
	jr	nz, .Sound3
	bit	3, a
	jr	nz, .Sound4
	bit	4, a
	jr	nz, .SoundLoop1
	bit	5, a
	jr	nz, .SoundLoop2
	bit	6, a
	jr	nz, .SoundSpeed

	jr	.type


.Sound1:		;0x01
	ld	a, (hl+)
	ldh	(0x12), a
	ld	a, (hl+)
	ldh	(0x13), a
	ld	a, (hl+)
	ldh	(0x14), a
	jr	.type

.Sound2:		;0x02
	ld	a, (hl+)
	ldh	(0x17), a
	ld	a, (hl+)
	ldh	(0x18), a
	ld	a, (hl+)
	ldh	(0x19), a
	jr	.type

.Sound3:		;0x04
	ld	a, (hl+)
	ldh	(0x1C), a
	ld	a, (hl+)
	ldh	(0x1D), a
	ld	a, #0x87
;	ld	a, (hl+)
	ldh	(0x1E), a
	jr	.type

.Sound4:		;0x08
	ld	a, (hl+)
	ldh	(0x21), a
	ld	a, (hl+)
	ldh	(0x22), a
	ld	a, #0x80
;	ld	a, (hl+)
	ldh	(0x23), a
	jr	.type

.SoundLoop1:	;0x10
	ld	a, l
	ld	(_playloop+0), a
	ld	a, h
	ld	(_playloop+0), a
	jr	.type

.SoundLoop2:	;0x20
	ld	a, (_playloop+0)
	ld	l, a
	ld	a, (_playloop+0)
	ld	h, a
	jr	.type

.SoundSpeed:	;0x40
	ld	a, (hl+)
	ld	(_timmod+0), a
	ld	(_timctr+0), a
	ld	a, (hl+)
	ld	(_timmod+1), a
	ld	(_timctr+1), a
	jr	.type
