//////////////////////////////////////////////////////////////////////////////
// playerc.c                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
//#include "player.h"

//////////////////////////////////////////////////////////////////////////////
// definitions                                                              //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
unsigned char squarewave[] =
{
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
};

extern unsigned int playtick;
extern void* playpos;
extern void* playloop;
extern unsigned long timctr;
extern unsigned long timmod;

//////////////////////////////////////////////////////////////////////////////
// InitSound                                                                //
//////////////////////////////////////////////////////////////////////////////
void InitSound()
{
	unsigned int i;
	unsigned char* p;

	NR52_REG = 0x8F; // sounds 1-4 on
	NR51_REG = 0xFF; // ouput all sounds
	NR50_REG = 0x77; // volume for SO1 & SO2

	// sound 1
	NR10_REG = 0x00; // sweep: time(0-7), inc/dec(0-1), shift(0-7)
	NR11_REG = 0x40; // wave pattern duty(0-3), sound length(0-63)

	// sound 2
	NR21_REG = 0x40; // wave pattern duty(0-3), sound length(0-63)

	// sound 3
	NR30_REG = 0x00; // sound 3 output off
	p = (unsigned char*)0xFF30;
	for (i=0; i<16; i++)
	{
		*p++ = squarewave[i];
	}
	NR30_REG = 0x80; // sound 3 output OK
	NR32_REG = 0x20; // output level
}

//////////////////////////////////////////////////////////////////////////////
// StartPlayer                                                              //
//////////////////////////////////////////////////////////////////////////////
void StartPlayer(void* data)
{
	playpos = data;
	playtick = 0;

	TAC_REG = 4;		// 8122Hz
	TMA_REG = 256-16;	// 512Hz

	timctr = timmod = 485;

	IE_REG |= TIM_IFLAG;
}
