//////////////////////////////////////////////////////////////////////////////
// scroller.c                                                               //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "scroller.h"
#include "asm.h"

//////////////////////////////////////////////////////////////////////////////
// definitions                                                              //
//////////////////////////////////////////////////////////////////////////////
#define INCCNT 18
#define C 6
#define B 4
#define A 2
#define _ 1

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
unsigned long pos;

char scroller_text[] =
	"           "
	"HELLO GUYS!, THIS IS DARKFADER'S INTRO FOR THE GBDEV'99 COMPO CALLED 'VECTRONY' (OR WHATEVER).  "
	"HOPE YOU CAN READ THIS WEIRD SCROLLER ;-)  "
	"THE VECTORS ARE CALCED USING AN LOG/ANTILOG TABLE OF 512 BYTES. IT WAS 16KB, BUT IT SEEMED A BIT LARGE FOR A SIZE LIMITED DEMO.  "
	"TRIED TO OPTIMIZE IT AS MUCH AS POSSIBLE.  "
	"GREETS I.N.P.O: WOODEN SPOON, JEFF, HARRY, MARTIN, MEGAMAN_X, IAN, DAVID, MARC, SEAN, MARTIJN, QUANG, PACMAN, AND OTHERS,...  "
	"OKAY, BACK TO THE START..."
	"           ";

char scroller_xlat[] =
{
	//0
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//32
	0,2,3,0,0,0,0,4,5,6,0,0,7,8,9,0,
	//48
	10,11,12,13,14,15,16,17,18,19,
	//58
	20,21,0,22,0,23,24,
	//65
	25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,
	//91
	0,0,0,0,51,4,
	//97
	25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,
	//123
	0,0,0,0,0,
	//128
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};

UWORD* scroller_pal;
UWORD* scroller_startpal;

UWORD scroller_pals[] =	// 6*8
{
	RGB(31, 0, 0),
	RGB(31, 4, 0),
	RGB(31, 8, 0),
	RGB(31,12, 0),
	RGB(31,16, 0),
	RGB(31,20, 0),
	RGB(31,24, 0),
	RGB(31,28, 0),

	RGB(31,31, 0),
	RGB(28,31, 0),
	RGB(24,31, 0),
	RGB(20,31, 0),
	RGB(16,31, 0),
	RGB(12,31, 0),
	RGB( 8,31, 0),
	RGB( 4,31, 0),

	RGB( 0,31, 0),
	RGB( 0,31, 4),
	RGB( 0,31, 8),
	RGB( 0,31,12),
	RGB( 0,31,16),
	RGB( 0,31,20),
	RGB( 0,31,24),
	RGB( 0,31,28),

	RGB( 0,31,31),
	RGB( 0,28,31),
	RGB( 0,24,31),
	RGB( 0,20,31),
	RGB( 0,16,31),
	RGB( 0,12,31),
	RGB( 0, 8,31),
	RGB( 0, 4,31),

	RGB( 0, 0,31),
	RGB( 4, 0,31),
	RGB( 8, 0,31),
	RGB(12, 0,31),
	RGB(16, 0,31),
	RGB(20, 0,31),
	RGB(24, 0,31),
	RGB(28, 0,31),

	RGB(31, 0,31),
	RGB(31, 0,28),
	RGB(31, 0,24),
	RGB(31, 0,20),
	RGB(31, 0,16),
	RGB(31, 0,12),
	RGB(31, 0, 8),
	RGB(31, 0, 4),

	// extra
	RGB(31, 0, 0),
	RGB(31, 4, 0),
	RGB(31, 8, 0),
	RGB(31,12, 0),
	RGB(31,16, 0),
	RGB(31,20, 0),
	RGB(31,24, 0),
	RGB(31,28, 0),
};

//////////////////////////////////////////////////////////////////////////////
// InitScroller                                                             //
//////////////////////////////////////////////////////////////////////////////
void InitScroller()
{
	pos=0;
	scroller_startpal = scroller_pals;
}

//////////////////////////////////////////////////////////////////////////////
// DoScroller                                                               //
//////////////////////////////////////////////////////////////////////////////
void DoScroller()
{
	unsigned int s;
	char *p = scroller_text + pos/16L;

	for (s=0; s<10; s++)
	{
		if (s<5)
		{
			unsigned long t = ((4-s)<<4) + (pos&15) + 32;
			move_sprite(39-s, 102 - t*t/128, 140);
		}

		if (s>=5)
		{
			unsigned long t = ((s-5)<<4) - (pos&15) + 32;
			move_sprite(39-s, 94 + t*t/128, 140);
		}
		
		if (!*p)
			pos=0;
		else
			set_sprite_tile(39-s, scroller_xlat[*p++]<<1);
		
		set_sprite_prop(39-s, 0);
	}

	pos += 2;
	
	if ((pos&3) == 0)
	{
		if (++scroller_startpal == scroller_pals+6*8) scroller_startpal = scroller_pals;
	}
}
